'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _css = require('antd/lib/tabs/style/css');

var _tabs = require('antd/lib/tabs');

var _tabs2 = _interopRequireDefault(_tabs);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _css2 = require('antd/lib/modal/style/css');

var _modal3 = require('antd/lib/modal');

var _modal4 = _interopRequireDefault(_modal3);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _LoginForm = require('./LoginForm');

var _LoginForm2 = _interopRequireDefault(_LoginForm);

var _isomorphicFetch = require('isomorphic-fetch');

var _isomorphicFetch2 = _interopRequireDefault(_isomorphicFetch);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var appid = 'dingoakznbgimtvtwk49ki';
var redirectUrl = encodeURIComponent(location.protocol + '//employee.cathay-ins.com.cn/sso/receiveDdTmpAuth');
var GOTO_URL = 'https://oapi.dingtalk.com/connect/oauth2/sns_authorize?appid=' + appid + '&response_type=code&scope=snsapi_login&state=STATE&redirect_uri=' + redirectUrl;

var LoginModal = function (_Component) {
  (0, _inherits3.default)(LoginModal, _Component);

  function LoginModal(_ref) {
    var callbackUrl = _ref.callbackUrl;
    (0, _classCallCheck3.default)(this, LoginModal);

    // 用在页面版单点登陆中
    var _this = (0, _possibleConstructorReturn3.default)(this, (LoginModal.__proto__ || (0, _getPrototypeOf2.default)(LoginModal)).call(this));

    _this.state = { visible: false };
    _this.callbackUrl = callbackUrl;
    _this.handleIframeMessage = _this.handleIframeMessage.bind(_this);

    if (typeof window.addEventListener !== 'undefined') {
      window.addEventListener('message', _this.handleIframeMessage, false);
    } else if (typeof window.attachEvent !== 'undefined') {
      window.attachEvent('onmessage', _this.handleIframeMessage);
    }
    return _this;
  }

  (0, _createClass3.default)(LoginModal, [{
    key: 'show',
    value: function show(lastFetch) {
      this.lastFetch = lastFetch;
      this.setState({
        visible: true
      });
    }
  }, {
    key: 'close',
    value: function close() {
      this.setState({
        visible: false
      });
    }
  }, {
    key: 'receiveTmpAuthCodeIframe',
    value: function receiveTmpAuthCodeIframe(url) {
      var iframe = document.createElement('iframe');
      iframe.src = url;
      iframe.frameBorder = '0';
      iframe.allowTransparency = 'true';
      iframe.scrolling = 'no';

      document.body.appendChild(iframe);
      return iframe;
    }
  }, {
    key: 'doAuthByFetch',
    value: function doAuthByFetch(type, data) {
      var lastFetch = this.lastFetch;

      if (!lastFetch) {
        return;
      }

      var url = lastFetch.url;
      var options = lastFetch.options;
      var headers = options.headers;

      switch (type) {
        case 'ddScan':
          // 兼容方案 start，去掉之前请确定所有java sdk等升级到指定版本
          headers['CATHAY_AUTH_TYPE'] = 'ddScan';
          headers['CATHAY_AUTH_DD_TMP_CODE'] = data;
          // 兼容方案 end

          headers['CATHAY-AUTH-TYPE'] = 'ddScan';
          headers['CATHAY-AUTH-DD-TMP-CODE'] = data;
          break;
        case 'password':
          // 兼容方案 start，去掉之前请确定所有java sdk等升级到指定版本
          headers['CATHAY_AUTH_TYPE'] = 'password';
          headers['CATHAY_AUTH_USERNAME'] = encodeURIComponent(data.username);
          headers['CATHAY_AUTH_PASSWORD'] = data.password;
          // 兼容方案 end

          headers['CATHAY-AUTH-TYPE'] = 'password';
          headers['CATHAY-AUTH-USERNAME'] = encodeURIComponent(data.username);
          headers['CATHAY-AUTH-PASSWORD'] = data.password;
          break;
      }

      this.doVerify(url, options, type);
    }
  }, {
    key: 'fetchCanBeRecover',
    value: function fetchCanBeRecover() {
      var lastFetch = this.lastFetch;

      var minite10 = 10 * 60 * 1000;

      // 如果距离上个请求的时间在10min以上，那么判断为页面初始化后的单次数据请求，直接恢复数据
      if (lastFetch.intervalTime > minite10) {
        return true;
      }
      // 累计fetch请求数 < 10 认为是首次加载页面，暂无想到更严谨的判断方法
      // @TODO
      if (lastFetch.count < 10) {
        return false;
      } else {
        return true;
      }
    }
  }, {
    key: 'doVerify',
    value: function doVerify(url, options, type) {
      var _this2 = this;

      (0, _isomorphicFetch2.default)(url, options).then(function (res) {
        if (res.status == 401 || res.status == 400) {
          res.json().then(function (json) {
            var message = json.message || '账号或密码错误，请重试';

            var modal = _modal4.default.error({
              title: '登陆失败',
              content: message
            });
            setTimeout(function () {
              modal.destroy();
            }, 3000);
          });
        } else if (res.status == 200) {
          _this2.close();

          // 用在页面版单点登陆中
          if (_this2.callbackUrl) {
            var modal = _modal4.default.success({
              title: '登陆成功',
              content: '登陆成功，页面会即将跳转'
            });

            setTimeout(function () {
              location.href = _this2.callbackUrl;
            }, 500);

            // 用在Modal版单点登陆中
          } else if (_this2.fetchCanBeRecover()) {
            var _modal = _modal4.default.success({
              title: '登陆成功',
              content: '重新登陆成功，请重新完成个之前的操作'
            });
            setTimeout(function () {
              _modal.destroy();
            }, 500);
            // 用在Modal版单点登陆中
          } else {
            var _modal2 = _modal4.default.success({
              title: '登陆成功',
              content: '登陆成功，页面即将刷新'
            });

            setTimeout(function () {
              location.reload();
            }, 500);
          }
        } else {
          return _promise2.default.reject();
        }
      }).catch(function (err) {
        var modal = _modal4.default.error({
          title: '登陆失败',
          content: '登陆异常，请重试，本窗口3s消失'
        });
        setTimeout(function () {
          modal.destroy();
        }, 3000);
      });
    }
  }, {
    key: 'handleIframeMessage',
    value: function handleIframeMessage(event) {
      // 参考: https://open-doc.dingtalk.com/docs/doc.htm?treeId=168&articleId=104882&docType=1
      if (event.origin == 'https://login.dingtalk.com') {
        // 拿到loginTmpCode后就可以在这里构造跳转链接进行跳转了
        var loginTmpCode = event.data;
        this.iframe = this.receiveTmpAuthCodeIframe(GOTO_URL + '&loginTmpCode=' + loginTmpCode);
      } else {
        try {
          var json = JSON.parse(event.data);

          switch (json.type) {
            case 'tmpAuthCode':
              var tmpAuthCode = json.data;
              // TODO process tmpAuthCode
              this.doAuthByFetch('ddScan', tmpAuthCode);
              break;
          }
        } catch (e) {}
      }
    }
  }, {
    key: 'renderScanCode',
    value: function renderScanCode() {
      DDLogin({
        id: 'scanCode',
        goto: encodeURIComponent(GOTO_URL),
        style: '',
        href: '',
        width: '300px',
        height: '300px'
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var TabPane = _tabs2.default.TabPane;

      return _react2.default.createElement(
        _modal4.default,
        { title: '\u56FD\u6CF0\u7EDF\u4E00\u767B\u9646', visible: this.state.visible,
          onCancel: function onCancel() {
            _this3.close();
          },
          footer: '' },
        _react2.default.createElement(
          _tabs2.default,
          { type: 'card' },
          _react2.default.createElement(
            TabPane,
            { tab: '\u626B\u7801\u767B\u5F55', key: '1' },
            _react2.default.createElement('div', { id: 'scanCode', style: {
                width: 300,
                height: 300,
                marginBottom: 30,
                marginLeft: 50
              } }),
            _react2.default.createElement(
              'div',
              { className: 'sso-tips' },
              '\u56FD\u6CF0\u5458\u5DE5\u8D26\u53F7\u9ED8\u8BA4\u7ED1\u5B9A\u4E86\u9489\u9489\u626B\u7801\uFF0C\u5176\u4ED6\u8D26\u53F7\u9700\u8981\u767B\u9646\u540E\u4E3B\u52A8\u7ED1\u5B9A: ',
              _react2.default.createElement(
                'a',
                { href: '//home.cathay-ins.com.cn/account/bind-dd' },
                '\u7ED1\u5B9A\u9489\u9489'
              )
            )
          ),
          _react2.default.createElement(
            TabPane,
            { tab: '\u8F93\u5165\u767B\u5F55', key: '2' },
            _react2.default.createElement(_LoginForm2.default, { doLogin: function doLogin(data) {
                _this3.doAuthByFetch('password', data);
              } }),
            _react2.default.createElement(
              'div',
              { className: 'sso-tips' },
              '\u5FD8\u8BB0\u5BC6\u7801\uFF1F ',
              _react2.default.createElement(
                'a',
                { href: '//home.cathay-ins.com.cn/nologin/password/recover' },
                '\u627E\u56DE\u5BC6\u7801'
              ),
              '\xA0\xA0\xA0 or  \xA0\xA0\xA0 \u8D26\u53F7\u88AB\u9501\uFF1F ',
              _react2.default.createElement(
                'a',
                { href: '//home.cathay-ins.com.cn/nologin/password/unlock' },
                '\u8D26\u53F7\u89E3\u9501'
              )
            )
          )
        )
      );
    }
  }]);
  return LoginModal;
}(_react.Component);

var _default3 = LoginModal;
exports.default = _default3;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(appid, 'appid', 'src/components/LoginModal.js');

  __REACT_HOT_LOADER__.register(redirectUrl, 'redirectUrl', 'src/components/LoginModal.js');

  __REACT_HOT_LOADER__.register(GOTO_URL, 'GOTO_URL', 'src/components/LoginModal.js');

  __REACT_HOT_LOADER__.register(LoginModal, 'LoginModal', 'src/components/LoginModal.js');

  __REACT_HOT_LOADER__.register(_default3, 'default', 'src/components/LoginModal.js');
}();

;