'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LoginModal = exports.serializeQuery = undefined;

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _isomorphicFetch = require('isomorphic-fetch');

var _isomorphicFetch2 = _interopRequireDefault(_isomorphicFetch);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _url = require('url');

var _url2 = _interopRequireDefault(_url);

var _formatOptions2 = require('./utils/formatOptions.js');

var _formatOptions3 = _interopRequireDefault(_formatOptions2);

var _LoginModal = require('./components/LoginModal');

var _LoginModal2 = _interopRequireDefault(_LoginModal);

var _serializeQuery = require('./utils/serializeQuery.js');

var _serializeQuery2 = _interopRequireDefault(_serializeQuery);

var _errWrapper = require('./components/errWrapper');

var _errWrapper2 = _interopRequireDefault(_errWrapper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var serializeQuery = exports.serializeQuery = _serializeQuery2.default;

var lastFetch = {
  count: 0
};

var loginModal = null;
function getLoginModal() {
  if (!loginModal) {
    var container = document.createElement('div');
    document.body.appendChild(container);
    loginModal = _reactDom2.default.render(_react2.default.createElement(_LoginModal2.default, null), container);
  }
  return loginModal;
}

function universalFetchProcess(res) {
  var status = res.status;

  var rejectObject = {
    status: status,
    message: 'universe fetch process end'

    // 306 页面跳转
  };if (status === 306) {
    window.location.href = res.headers.get('location');

    rejectObject.type = 'redirect';
    return _promise2.default.reject(rejectObject);
    // 401 无权限，进行登录操作
  } else if (status === 401) {
    var _loginModal = getLoginModal();
    _loginModal.show(lastFetch);
    _loginModal.renderScanCode();

    rejectObject.type = 'noPrivilege';
    return _promise2.default.reject(rejectObject);
    // 其他非200错误进行展示处理，兼容json及非json(500)
  } else if (status < 200 || status > 299) {
    res.text().then(function (errorBody) {
      var message = errorBody;
      try {
        var json = JSON.parse(errorBody);
        message = json.message || (0, _stringify2.default)(json, null, 4);
      } catch (e) {}
      (0, _errWrapper2.default)(message);
    });

    rejectObject.type = 'errorMessage';
    return _promise2.default.reject(rejectObject);
  } else {
    // 200 系列
    return res.json();
  }
}

function processCtoken(url) {
  var tokenEl = document.getElementsByTagName('meta')['_csrf'];
  if (tokenEl) {
    var token = tokenEl.content;
    if (~url.indexOf('?')) {
      url += '&_csrf=';
    } else {
      url += '?_csrf=';
    }
    url += token;
  }
  return url;
}

// 只记录 /api 前缀的请求，这些需要登录
function memoryFetch(newUrl, ops) {
  var timeNow = Date.now();

  var parsedUrl = _url2.default.parse(newUrl);

  // 黑名单域名，不会进行记忆
  if (parsedUrl.host && parsedUrl.host.indexOf('bbs.cathay-ins.com.cn') >= 0) {
    return;
  }
  if (parsedUrl.path.indexOf('/api') === 0) {
    if (lastFetch.time) {
      lastFetch.intervalTime = timeNow - lastFetch.time;
    }
    lastFetch.time = timeNow;
    lastFetch.url = newUrl;
    lastFetch.options = ops;
    lastFetch.count++;
  }
}

var _default = function _default(rawUrl, options) {
  var _formatOptions = (0, _formatOptions3.default)(rawUrl, options),
      url = _formatOptions.url,
      ops = _formatOptions.ops;

  var newUrl = processCtoken(url);

  memoryFetch(newUrl, ops);

  return (0, _isomorphicFetch2.default)(newUrl, ops).then(universalFetchProcess);
};

exports.default = _default;
exports.LoginModal = _LoginModal2.default;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(serializeQuery, 'serializeQuery', 'src/index.js');

  __REACT_HOT_LOADER__.register(lastFetch, 'lastFetch', 'src/index.js');

  __REACT_HOT_LOADER__.register(loginModal, 'loginModal', 'src/index.js');

  __REACT_HOT_LOADER__.register(getLoginModal, 'getLoginModal', 'src/index.js');

  __REACT_HOT_LOADER__.register(universalFetchProcess, 'universalFetchProcess', 'src/index.js');

  __REACT_HOT_LOADER__.register(processCtoken, 'processCtoken', 'src/index.js');

  __REACT_HOT_LOADER__.register(memoryFetch, 'memoryFetch', 'src/index.js');

  __REACT_HOT_LOADER__.register(_default, 'default', 'src/index.js');
}();

;