import React, { Component } from 'react'
import { Button, Input, Form } from 'antd'

class LoginForm extends Component {
  onSubmit = (e) => {
    e.preventDefault()
    this
      .props
      .form
      .validateFields((err, data) => {
        if (!err) {
          let loginMessage = {
            username: data.username,
            password: data.password
          }
          this
            .props
            .doLogin(loginMessage)
        }
      })
  }

  render() {
    const FormItem = Form.Item
    const { getFieldDecorator } = this.props.form
    const formItemLayout = {
      labelCol: {
        xs: {
          span: 24
        },
        sm: {
          span: 6
        }
      },
      wrapperCol: {
        xs: {
          span: 24
        },
        sm: {
          span: 14
        }
      }
    }
    const tailFormItemLayout = {
      wrapperCol: {
        xs: {
          span: 24,
          offset: 0
        },
        sm: {
          span: 14,
          offset: 6
        }
      }
    }

    return (
      <Form onSubmit={this.onSubmit}>
        <FormItem {...formItemLayout} label="账号">
          {getFieldDecorator('username', {
            rules: [
              {
                required: true,
                message: '请输入账号!'
              },
              // {
              //   validator: (rule, username, callback) => {

              //     let hasError = true
              //     if (username.length == 11) {
              //       hasError = false
              //     } else if (username.length == 10) {
              //       hasError = false
              //     } else if (~username.indexOf('@') && ~username.indexOf('.')) {
              //       hasError = false
              //     }

              //     if (hasError) {
              //       callback(true)
              //     } else {
              //       callback()
              //     }
              //   },
              //   message: "请输入正确的账号格式，邮箱为完整地址，手机11位，员工号10位"
              // }
            ]
          })(<Input size="large" placeholder="请输入账号(手机号码、邮箱或工号)" />)}
        </FormItem>

        <FormItem {...formItemLayout} label="密码">
          {getFieldDecorator('password', {
            rules: [
              {
                required: true,
                message: '请输入密码!'
              }
            ]
          })(<Input size="large" type="password" placeholder="请输入密码" />)}
        </FormItem>

        <FormItem {...tailFormItemLayout}>

          <Button type="primary" size="large" htmlType="submit">
            确定
                    </Button>

        </FormItem>
      </Form>
    )
  }
}

export default Form.create()(LoginForm)
