import fetch from 'isomorphic-fetch'

import formatOptions from './utils/formatOptions.js'
import serialize from './utils/serializeQuery.js'

export const serializeQuery = serialize

export default function (rawUrl, options) {
  const { url, ops } = formatOptions(rawUrl, options)
  return fetch(url, ops)
    .then(response => response.json())
    .then(result => {
      const { success = '' } = result
      if (success === false && message) window.alert(message)
      return result
    })
    .catch(error => {
      const { statusText = '', status = '' } = error
      if (statusText) {
        window.alert(`网络连接错误，错误信息：${statusText}`)
      }

      if (status === 399) {
        window.location.href = error.headers.get('location')
      }
      window.alert('网络连接错误，请重试。')
    })
}
